using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using PlexityHide.GTP;
using System.Drawing.Imaging;
using System.Drawing;
using AjaxControlToolkit;

public partial class WebProjectPlanner : System.Web.UI.Page 
{
  private PlexityHide.GTP.WEB.Gantt_ASPSettings gantt_ASPSettings1;

    private LetsBuild_ProjectPlanner.Form1 f1;
    protected void Page_Load(object sender, EventArgs e)
    {
      this.gantt_ASPSettings1 = new PlexityHide.GTP.WEB.Gantt_ASPSettings();      
      gantt_ASPSettings1.Gantt_ASP = Gantt_ASP1;
      Gantt_ASP1.ClientSideTimeItemCreateMode=true;

      f1 = new LetsBuild_ProjectPlanner.Form1();
      f1.DoAllTheInitWork();
      gantt_ASPSettings1.WrapGantt(f1.gantt1);
      f1.Height=700;
      Gantt_ASP1.Height=700;


      if (Page.Session["loaded_proj"] == null || (bool)(Page.Session["loaded_proj"]) == false)
      {
        f1.dataSet1.ReadXml(Page.MapPath(".\\App_Data\\project.xml"));
        System.IO.MemoryStream ms = new System.IO.MemoryStream();
        f1.dataSet1.WriteXml(ms);
        Page.Session.Add("thedata_proj", ms);
        Page.Session.Add("loaded_proj", true);
      }
      else
      {
        System.IO.MemoryStream ms = Page.Session["thedata_proj"] as System.IO.MemoryStream;
        ms.Position=0;
        f1.dataSet1.ReadXml(ms);
      }
      
      if (!IsPostBack)
      {
        Gantt_ASP1.Gantt.Grid.Refresh(); // Makesure the grid is rendered and the datasources get initiated
        foreach (GridNode gn in Gantt_ASP1.Gantt.Grid.RootNodes)
        {
          Gantt_ASP1.SetExpandedStatusForGridNode(gn, true);
        }

        Gantt_ASP1.SetSortColumn(true,1);
      }


      PlexityHide.GTP.WEB.Gantt_ASP.ClientSideJavaScript_TimeItemClick = "alert('Ok, I clicked a timeitem (with UserString='+aClientTimeItem.UserString+'), And  I choose to supress the postback by setting continueWithPostBack=false');\r\n continueWithPostBack=false;";

      PlexityHide.GTP.WEB.Gantt_ASP.ClientSideJavaScript_TimeItemInit = "aImgElement.title=aClientTimeItem.UserString;\r\n";
      //PlexityHide.GTP.WEB.Gantt_ASP.ClientSideJavaScript_TimeItemInit = "aImgElement.onmouseover=(function(event){alert('hello');});\r\n";


      Gantt_ASP1.OnTimeItemUserStringPrepare += new PlexityHide.GTP.WEB.TimeItemUserStringPrepareEvent(Gantt_ASP1_OnTimeItemUserStringPrepare);
      Gantt_ASP1.OnCellDivAttributesString += new PlexityHide.GTP.WEB.CellDivAttributesStringEvent(Gantt_ASP1_OnCellDivAttributesString);


      Gantt_ASP1.Gantt.Grid.Columns[0].SortEnable=true;
      Gantt_ASP1.Gantt.Grid.Columns[1].SortEnable = true;



      /*
            // When the Gantt_ASP1.UseColumnWidths is set to true, the gridcolumns will have their designed width, 
            // when set to false the gridcolumns adapts to the given content
            Gantt_ASP1.UseColumnWidths=true;
            Gantt_ASP1.Gantt.GridWidth=300;
            Gantt_ASP1.Gantt.Grid.Columns[0].Width = 200;
            Gantt_ASP1.Gantt.Grid.Columns[1].Width = 200;
       */     
    }

  void Gantt_ASP1_OnCellDivAttributesString(PlexityHide.GTP.WEB.Gantt_ASP aGantt, PlexityHide.GTP.WEB.CellDivArgs e)
  {
    e.result = "title='A unique tooltip for this cell " + e.Cell.Index.ToString() + " " + e.Cell.Content.Value.ToString()+"'";
    //e.result = "/>AnImage<img src='plexityhide.gif'/>And also some text and a <a href='vafan'>link</a><div";
     
    
  }

  void Gantt_ASP1_OnTimeItemUserStringPrepare(PlexityHide.GTP.WEB.Gantt_ASP aGantt, PlexityHide.GTP.WEB.TimeItemUserStringPrepareArgs e)
  {
    e.result="This time item starts st "+e.ti.Start.ToLongDateString();
  }

  private void InitializeComponent()
  {
    this.gantt_ASPSettings1 = new PlexityHide.GTP.WEB.Gantt_ASPSettings();
    // 
    // gantt_ASPSettings1
    // 
    // 
    // 
    // 
    this.gantt_ASPSettings1.Gantt.AutoScrollGridEnable = true;
    this.gantt_ASPSettings1.Gantt.AutoScrollTimeEnable = true;
    this.gantt_ASPSettings1.Gantt.CollisionDetectionSyncron = true;
    this.gantt_ASPSettings1.Gantt.ContextMenuStripTimeItemArea = null;
    this.gantt_ASPSettings1.Gantt.DateScalerHeight = 46;
    this.gantt_ASPSettings1.Gantt.DateScalerProperties.ContextMenuStrip = null;
    this.gantt_ASPSettings1.Gantt.DateScalerProperties.FishEyeColor = System.Drawing.Color.AliceBlue;
    this.gantt_ASPSettings1.Gantt.DateScalerProperties.FishEyeenabled = false;
    this.gantt_ASPSettings1.Gantt.DateScalerProperties.FishEyeMagnification = PlexityHide.GTP.FishEyeMagnification.M1;
    this.gantt_ASPSettings1.Gantt.DateScalerProperties.LowerBound = new System.DateTime(1000, 1, 1, 0, 0, 0, 0);
    this.gantt_ASPSettings1.Gantt.DateScalerProperties.MarkerTextColor = System.Drawing.Color.Black;
    this.gantt_ASPSettings1.Gantt.DateScalerProperties.ResizeType = PlexityHide.GTP.ResizingType.StartAndStopLocked;
    this.gantt_ASPSettings1.Gantt.DateScalerProperties.ScaleMarkerColor = System.Drawing.Color.Black;
    this.gantt_ASPSettings1.Gantt.DateScalerProperties.ShowWeekNumbers = false;
    this.gantt_ASPSettings1.Gantt.DateScalerProperties.SpanTextColor = System.Drawing.Color.SlateGray;
    this.gantt_ASPSettings1.Gantt.DateScalerProperties.StartOfWeek = System.DayOfWeek.Sunday;
    this.gantt_ASPSettings1.Gantt.DateScalerProperties.StartTime = new System.DateTime(2007, 2, 5, 4, 40, 33, 773);
    this.gantt_ASPSettings1.Gantt.DateScalerProperties.StopTime = new System.DateTime(2007, 2, 25, 7, 13, 44, 862);
    this.gantt_ASPSettings1.Gantt.DateScalerProperties.UpperBound = new System.DateTime(8000, 1, 1, 0, 0, 0, 0);
    this.gantt_ASPSettings1.Gantt.DateScalerProperties.UseDayNumbersNotWeeks = true;
    this.gantt_ASPSettings1.Gantt.DrawPyjamas = true;
    this.gantt_ASPSettings1.Gantt.FocusedTimeItem = null;
    this.gantt_ASPSettings1.Gantt.GridProperties.AutoCreateColumnsFromDataset = false;
    this.gantt_ASPSettings1.Gantt.GridProperties.BackColor = System.Drawing.SystemColors.Control;
    this.gantt_ASPSettings1.Gantt.GridProperties.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
    this.gantt_ASPSettings1.Gantt.GridProperties.BottomColor = System.Drawing.Color.White;
    this.gantt_ASPSettings1.Gantt.GridProperties.ContextMenuStrip = null;
    this.gantt_ASPSettings1.Gantt.GridProperties.DrawPyjamas = true;
    this.gantt_ASPSettings1.Gantt.GridProperties.HasHeader = true;
    this.gantt_ASPSettings1.Gantt.GridProperties.ImageList = null;
    this.gantt_ASPSettings1.Gantt.GridProperties.PyjamasColor = System.Drawing.SystemColors.ControlLight;
    this.gantt_ASPSettings1.Gantt.GridProperties.PyjamasGradientColor = System.Drawing.SystemColors.ControlLightLight;
    this.gantt_ASPSettings1.Gantt.GridProperties.RootNodes_DataMember = null;
    this.gantt_ASPSettings1.Gantt.GridProperties.RootNodes_DataSource = null;
    this.gantt_ASPSettings1.Gantt.GridWidth = 100;
    this.gantt_ASPSettings1.Gantt.ImageList = null;
    this.gantt_ASPSettings1.Gantt.Location = new System.Drawing.Point(0, 0);
    this.gantt_ASPSettings1.Gantt.Name = "Gantt";
    this.gantt_ASPSettings1.Gantt.PyjamasColor = System.Drawing.SystemColors.ControlLightLight;
    this.gantt_ASPSettings1.Gantt.PyjamasGradientColor = System.Drawing.SystemColors.ControlLight;
    this.gantt_ASPSettings1.Gantt.ScheduleMode = false;
    this.gantt_ASPSettings1.Gantt.Size = new System.Drawing.Size(408, 424);
    this.gantt_ASPSettings1.Gantt.TabIndex = 0;
    this.gantt_ASPSettings1.Gantt.TimeMoveMarkerDate = true;
    this.gantt_ASPSettings1.Gantt.TimeMoveMarkerRow = true;
    this.gantt_ASPSettings1.Gantt.TodayLine = true;
    this.gantt_ASPSettings1.Gantt.TodayLineColor = System.Drawing.Color.Black;
    this.gantt_ASPSettings1.Gantt.TurnOffAllCollisionDetect = true;
    this.gantt_ASPSettings1.Gantt.VerticalDayStripes = false;
    this.gantt_ASPSettings1.Gantt.VerticalDayStripes_Days = new bool[] {
        true,
        false,
        false,
        false,
        false,
        false,
        true};
    this.gantt_ASPSettings1.Gantt.VerticalDayStripesColor = System.Drawing.Color.LightGray;
    this.gantt_ASPSettings1.Gantt.VerticalLines = true;
    this.gantt_ASPSettings1.Gantt.VerticalLinesColor = System.Drawing.Color.Black;

  }

  protected void Gantt_ASP1_OnClientSideChangesApplied(object sender, EventArgs e)
  {
    System.IO.MemoryStream ms = new System.IO.MemoryStream();
    f1.dataSet1.WriteXml(ms);
    Page.Session.Add("thedata_proj", ms);

    Gantt_ASP1.Gantt.Grid.Refresh();
    Gantt_ASP1.Gantt.TimeItemArea.Refresh();
    if (Gantt_ASP1.Gantt.Grid.GridStructure.LastDrawnNode != null)
    {
        Gantt_ASP1.Height = Gantt_ASP1.Gantt.Grid.GridStructure.LastDrawnNode.Rect().Bottom + Gantt_ASP1.Gantt.DateScalerHeight;
    }

  }

    protected void Gantt_ASP1_OnTimeItem_ClientClick(Gantt aGantt, TimeItemEventArgs e)
    {

        ScriptManager.RegisterClientScriptBlock(this.UpdatePanel1, typeof(UpdatePanel), "clientscript1", "window.open('YouClickedATimeItem.aspx?action=timeitem&id="+(e.TimeItem.ListItemWhenDataBound() as DataRowView)["id"].ToString() +"')", true);     

    }

    protected void Gantt_ASP1_OnGanttRow_ClientClick(PlexityHide.GTP.WEB.Gantt_ASP aGantt, PlexityHide.GTP.WEB.GanttRowClickEventArgs e)
    {
        ScriptManager.RegisterClientScriptBlock(this.UpdatePanel1, typeof(UpdatePanel), "clientscript1", "window.open('YouClickedATimeItem.aspx?action=ganttrow&id="+(e.Row.GridNode.ListItemWhenDataBound() as DataRowView)["id"].ToString()+"')", true);     

    }

    protected void Timer1_Tick(object sender, EventArgs e)
    {

    }

    protected void Gantt_ASP1_OnCellDivAttributesString1(PlexityHide.GTP.WEB.Gantt_ASP aGantt, PlexityHide.GTP.WEB.CellDivArgs e)
    {
    }

    protected void ButtonPrint_Click(object sender, EventArgs e)
    {
        Bitmap bm = new Bitmap(Gantt_ASP1.Gantt.Width, 300 + Gantt_ASP1.Gantt.DateScalerHeight);
        Graphics g = Graphics.FromImage(bm);
        Rectangle r = Rectangle.FromLTRB(0, 0, Gantt_ASP1.Gantt.Width, 300 + Gantt_ASP1.Gantt.DateScalerHeight);
        g.FillRectangle(Brushes.White, r);
        bool hasMorePages = false;

        Gantt_ASP1.Gantt.PrintInit(null);
        Gantt_ASP1.Gantt.PrintPage(g, r, Gantt_ASP1.Gantt.GridWidth + 10, Gantt_ASP1.Gantt.DateScalerHeight, ref hasMorePages);
        Gantt_ASP1.Gantt.PrintEnd();

        Response.Clear();
        Response.ContentType = "image/jpeg";
        Response.AddHeader("Content-Disposition", "attachment; filename=GanttASP.jpeg");
        bm.Save(Response.OutputStream, ImageFormat.Jpeg);
        Response.End();
        bm.Dispose();
        g.Dispose();
    }

  
}