using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using PlexityHide.GTP;

public partial class WebLetsBuild_WeeklyPlanner : System.Web.UI.Page
{
  private PlexityHide.GTP.WEB.Gantt_ASPSettings gantt_ASPSettings1;

  private LetsBuild_WeeklyPlanner_wf.Form1 f1;
  protected void Page_Load(object sender, EventArgs e)
  {
    this.gantt_ASPSettings1 = new PlexityHide.GTP.WEB.Gantt_ASPSettings();
    gantt_ASPSettings1.Gantt_ASP = Gantt_ASP1;

    f1 = new LetsBuild_WeeklyPlanner_wf.Form1();
    f1.gantt1.GridProperties.RootNodes_DataSource = null;
    f1.DoAllTheInitWork(new DateTime(2007, 2, 26));
    gantt_ASPSettings1.WrapGantt(f1.gantt1);
    f1.Height = 700;
    Gantt_ASP1.Height = 700;
    if (!Page.IsPostBack)
    {
      // Do not want to mess with the dates shown once the user is working
      Gantt_ASP1.StartTime = f1.gantt1.DateScaler.StartTime.AddHours(7);
      Gantt_ASP1.StopTime = Gantt_ASP1.StartTime.AddHours(8);
    }


    if (Page.Session["loaded_weekplan"] == null || (bool)(Page.Session["loaded_weekplan"]) == false)
    {
      f1.dataSet1.ReadXml(Page.MapPath(".\\App_Data\\weekdata.xml"));
      System.IO.MemoryStream ms = new System.IO.MemoryStream();
      f1.dataSet1.WriteXml(ms);
      Page.Session.Add("thedata_weekplan", ms);
      Page.Session.Add("loaded_weekplan", true);
    }
    else
    {
      System.IO.MemoryStream ms = Page.Session["thedata_weekplan"] as System.IO.MemoryStream;
      ms.Position = 0;
      f1.dataSet1.ReadXml(ms);
    }
    f1.gantt1.GridProperties.RootNodes_DataSource = f1.dataSetDays;
    f1.gantt1.OnTimeItem_AfterCreateByMouse += new PlexityHide.GTP.TimeItemEvent(gantt1_OnTimeItem_AfterCreateByMouse); 
  }

  protected void Gantt_ASP1_OnClientSideChangesApplied(object sender, EventArgs e)
  {
    System.IO.MemoryStream ms = new System.IO.MemoryStream();
    f1.dataSet1.WriteXml(ms);
    Page.Session.Add("thedata_weekplan", ms);

  }

  private void gantt1_OnTimeItem_AfterCreateByMouse(Gantt aGantt, TimeItemEventArgs e)
  {
    e.Allow = false; // We are databound!!!

    if (e.TimeItem.GanttRow != null)
    {
      int foreignKeyForResource = (int)(e.TimeItem.GanttRow.GridNode.ListItemWhenDataBound() as DataRowView)["Id"];

      DataRow r = f1.dataSet1.Tables["Booking"].NewRow();
      r["Text"] = "Note This was created by click and drag";
      // We are clicking on the time scale equal to Sunday, we have set TimeSpanOffset to 0,-1,-2,-3 etc on the days to 
      // get them to render side by so we can visually compare them in time...
      // When we add new Bookings we must compensate the click with respect to the TimeSpanOffset .Add(e.TimeItem.GanttRow.TimeSpanOffset)
      r["Start"] = e.TimeItem.Start.Add(-e.TimeItem.GanttRow.TimeSpanOffset);
      r["Stop"] = e.TimeItem.Stop.Add(-e.TimeItem.GanttRow.TimeSpanOffset);

      r["Color"] = aGantt.TimeItemLayouts[f1._rand.Next(0, aGantt.TimeItemLayouts.Count)].Name;
      f1.dataSet1.Tables["Booking"].Rows.Add(r);
    }

  }

}
